# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetPredefinedUrlCategoryOverrideResult',
    'AwaitableGetPredefinedUrlCategoryOverrideResult',
    'get_predefined_url_category_override',
    'get_predefined_url_category_override_output',
]

@pulumi.output_type
class GetPredefinedUrlCategoryOverrideResult:
    """
    A collection of values returned by getPredefinedUrlCategoryOverride.
    """
    def __init__(__self__, action=None, audit_comment=None, config_type=None, id=None, name=None, rulestack=None, update_token=None):
        if action and not isinstance(action, str):
            raise TypeError("Expected argument 'action' to be a str")
        pulumi.set(__self__, "action", action)
        if audit_comment and not isinstance(audit_comment, str):
            raise TypeError("Expected argument 'audit_comment' to be a str")
        pulumi.set(__self__, "audit_comment", audit_comment)
        if config_type and not isinstance(config_type, str):
            raise TypeError("Expected argument 'config_type' to be a str")
        pulumi.set(__self__, "config_type", config_type)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if rulestack and not isinstance(rulestack, str):
            raise TypeError("Expected argument 'rulestack' to be a str")
        pulumi.set(__self__, "rulestack", rulestack)
        if update_token and not isinstance(update_token, str):
            raise TypeError("Expected argument 'update_token' to be a str")
        pulumi.set(__self__, "update_token", update_token)

    @property
    @pulumi.getter
    def action(self) -> str:
        """
        The action to take. Valid values are `none`, `allow`, `alert`, or `block`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="auditComment")
    def audit_comment(self) -> str:
        """
        The audit comment.
        """
        return pulumi.get(self, "audit_comment")

    @property
    @pulumi.getter(name="configType")
    def config_type(self) -> Optional[str]:
        """
        Retrieve either the candidate or running config. Valid values are `candidate` or `running`. Defaults to `candidate`.
        """
        return pulumi.get(self, "config_type")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def rulestack(self) -> str:
        """
        The rulestack.
        """
        return pulumi.get(self, "rulestack")

    @property
    @pulumi.getter(name="updateToken")
    def update_token(self) -> str:
        """
        Update token.
        """
        return pulumi.get(self, "update_token")


class AwaitableGetPredefinedUrlCategoryOverrideResult(GetPredefinedUrlCategoryOverrideResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPredefinedUrlCategoryOverrideResult(
            action=self.action,
            audit_comment=self.audit_comment,
            config_type=self.config_type,
            id=self.id,
            name=self.name,
            rulestack=self.rulestack,
            update_token=self.update_token)


def get_predefined_url_category_override(config_type: Optional[str] = None,
                                         name: Optional[str] = None,
                                         rulestack: Optional[str] = None,
                                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPredefinedUrlCategoryOverrideResult:
    """
    Data source for retrieving a predefined URL category override.

    ## Admin Permission Type

    * `Rulestack` (for `scope="Local"`)
    * `Global Rulestack` (for `scope="Global"`)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudngfwaws as cloudngfwaws

    r = cloudngfwaws.Rulestack("r",
        name="my-rulestack",
        scope="Local",
        account_id="12345",
        description="Made by Pulumi",
        profile_config={
            "anti_spyware": "BestPractice",
        })
    example = cloudngfwaws.get_predefined_url_category_override_output(rulestack=r.name,
        name="foobar")
    ```


    :param str config_type: Retrieve either the candidate or running config. Valid values are `candidate` or `running`. Defaults to `candidate`.
    :param str name: The name.
    :param str rulestack: The rulestack.
    """
    __args__ = dict()
    __args__['configType'] = config_type
    __args__['name'] = name
    __args__['rulestack'] = rulestack
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudngfwaws:index/getPredefinedUrlCategoryOverride:getPredefinedUrlCategoryOverride', __args__, opts=opts, typ=GetPredefinedUrlCategoryOverrideResult).value

    return AwaitableGetPredefinedUrlCategoryOverrideResult(
        action=pulumi.get(__ret__, 'action'),
        audit_comment=pulumi.get(__ret__, 'audit_comment'),
        config_type=pulumi.get(__ret__, 'config_type'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        rulestack=pulumi.get(__ret__, 'rulestack'),
        update_token=pulumi.get(__ret__, 'update_token'))
def get_predefined_url_category_override_output(config_type: Optional[pulumi.Input[Optional[str]]] = None,
                                                name: Optional[pulumi.Input[str]] = None,
                                                rulestack: Optional[pulumi.Input[str]] = None,
                                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPredefinedUrlCategoryOverrideResult]:
    """
    Data source for retrieving a predefined URL category override.

    ## Admin Permission Type

    * `Rulestack` (for `scope="Local"`)
    * `Global Rulestack` (for `scope="Global"`)

    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudngfwaws as cloudngfwaws

    r = cloudngfwaws.Rulestack("r",
        name="my-rulestack",
        scope="Local",
        account_id="12345",
        description="Made by Pulumi",
        profile_config={
            "anti_spyware": "BestPractice",
        })
    example = cloudngfwaws.get_predefined_url_category_override_output(rulestack=r.name,
        name="foobar")
    ```


    :param str config_type: Retrieve either the candidate or running config. Valid values are `candidate` or `running`. Defaults to `candidate`.
    :param str name: The name.
    :param str rulestack: The rulestack.
    """
    __args__ = dict()
    __args__['configType'] = config_type
    __args__['name'] = name
    __args__['rulestack'] = rulestack
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudngfwaws:index/getPredefinedUrlCategoryOverride:getPredefinedUrlCategoryOverride', __args__, opts=opts, typ=GetPredefinedUrlCategoryOverrideResult)
    return __ret__.apply(lambda __response__: GetPredefinedUrlCategoryOverrideResult(
        action=pulumi.get(__response__, 'action'),
        audit_comment=pulumi.get(__response__, 'audit_comment'),
        config_type=pulumi.get(__response__, 'config_type'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        rulestack=pulumi.get(__response__, 'rulestack'),
        update_token=pulumi.get(__response__, 'update_token')))
